////////////////////////////////////////////
//  OtBbNteXgvO      //
//  2016/2/4  G121300N000  global.h       //
//  PIC18F452  MPLAB v8.92  C18 v3.47     //
////////////////////////////////////////////

#ifndef _GLOBAL_H
#define _GLOBAL_H

///// CPU Type
#include <p18f452.h>

///// ^̒Zk
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

///// Delay
#include <delays.h>
#define CONFIG_MHZ 20

///// Timer
#define TIMER_NUM           8
#define TIMER_FONT          0

extern volatile uint tics;
extern void timer_init(void);
extern void timer_start(int, uint);
extern void timer_restart(int, uint);
extern void timer_cancel(int);
extern int timer_check(int);
extern int timer_check_start(int);

///// font
extern rom const char Font8[256][8];
extern rom const char Font16[14][32];

///// ImageData
extern rom const char Img_data1[512];
extern rom const char Img_data2[512];
extern rom const char Img_data3[512];

///// gLcd
#define     DB      PORTD
#define     CS      LATAbits.LATA3
#define     RST     LATAbits.LATA5
#define     RW      LATEbits.LATE0
#define     DI      LATEbits.LATE1
#define     E       LATEbits.LATE2

extern void     lcg_reset(void);
extern uchar    lcg_status(void);
extern void     lcg_busy(void);
extern void     lcg_disp(uchar);
extern void     lcg_sline(uchar);
extern void     lcg_char(uchar, uchar, uchar);
extern void     lcg_str(uchar, uchar, rom const char*);
extern void     lcg_font(uchar, uchar, uchar);
extern void     lcg_clear(void);
extern void     lcg_font8x2(uchar, uchar, uchar);
extern void     lcg_pset(uchar, uchar, uchar);
extern void     lcg_line(int, int, int, int, uchar);
extern void     lcg_circle(int, int, int, uchar);
extern void     lcg_image(rom const char *);
extern void     lcg_paint(void);

///// main
extern void delay_ms(uint);

//////// Interrupt
extern volatile uchar cnt_DOWN;
extern volatile uchar cnt_UP;
extern volatile uchar cnt_ENT;
extern volatile uchar cnt_MODE;
typedef struct {
  unsigned _DOWN:1;
  unsigned _UP:1;
  unsigned _ENT:1;
  unsigned _MODE:1;
  unsigned _DOWN_L:1;
  unsigned _UP_L:1;
  unsigned _ENT_L:1;
  unsigned _MODE_L:1;
} INSWBITS;
extern INSWBITS INSWbits;
#define DOWN        INSWbits._DOWN
#define UP          INSWbits._UP
#define ENT         INSWbits._ENT
#define MODE        INSWbits._MODE
#define DOWN_L      INSWbits._DOWN_L
#define UP_L        INSWbits._UP_L
#define ENT_L       INSWbits._ENT_L
#define MODE_L      INSWbits._MODE_L

#endif
